﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Threading;
using System.Drawing;

namespace Bonhomme02
{
    class Marcher
    {
        Bonhomme bonhomme;
        IntPtr handle;
        int ySol;
        int resolution;
        int deltaXYmax = 10;
        int step;
        public Marcher()
        {

        }
        public Marcher(ref Bonhomme bonhomme, IntPtr handle, int ySol)
        {
            step = 0;
            this.bonhomme = bonhomme;
            this.handle = handle;
            this.ySol = ySol;
            resolution = 1;
            deltaXYmax = (int)Math.Round(3*bonhomme.jambe1.longueur.ABS/4);
            
            //Reset de tous les angle au cas ou
            bonhomme.Angle = Math.PI / 2;
            bonhomme.jambe1.SetAngle(Math.PI / 2, Math.PI / 2, 0);
            bonhomme.bras.Visible = false;
            bonhomme.bras.Cacher(handle);
            if(bonhomme.jambe1.Bas.CSG.Y != ySol) // On positionne le bonhomme sur le sol
            {
                Graphics gr = Graphics.FromHwnd(handle);
                bonhomme.Cacher(handle);
                Point newCoo;
                int longeurTTBonhome = bonhomme.jambe1.Bas.CSG.Y - bonhomme.CIG.Y ;// de pied.csg à bonhome.cig
                newCoo = new Point(bonhomme.CIG.X, ySol - longeurTTBonhome);
                bonhomme.Coordonnee = newCoo;
                bonhomme.Afficher(handle);
            }
        }
        public void Avancer(int vitesse)
        {
            step = 0;
            double old = 1, neww = 0;
            int dejaDeplacer = 0;
            while(step<=128)
            {
                Console.WriteLine(step + "::" + step % 5);
                dejaDeplacer = 0;
                switch (step%5)
                {
                    case 0:
                        while (dejaDeplacer < deltaXYmax) //Monte jambe 1
                        {
                            bonhomme.Cacher(handle);
                            bonhomme.jambe1.BougerBas(0, -resolution);
                            bonhomme.Afficher(handle);
                            dejaDeplacer += resolution;
                            Thread.Sleep(vitesse);
                        }
                       
                        break;
                    case 1:
                        while (dejaDeplacer < deltaXYmax)//avence corp + avancer jambe 1 jambe 2 fixe
                        {
                            bonhomme.Cacher(handle);
                            bonhomme.jambe2.BougerXHaut(resolution, ref bonhomme);
                            bonhomme.jambe1.BougerBas(resolution, 0);
                            bonhomme.Afficher(handle);
                            dejaDeplacer += resolution;
                            Thread.Sleep(vitesse);
                        }
                        CollerAuSol(ref bonhomme.jambe2); //Voir issues #24
                        break;
                    case 2:
                        while (bonhomme.jambe1.Bas.CSG.Y < ySol-1 && old != neww) //Descendre jambe 1 sur sol
                        {
                            bonhomme.Cacher(handle);
                            bonhomme.jambe1.BougerBas(0, resolution);
                            bonhomme.Afficher(handle);
                            dejaDeplacer += resolution;
                            Thread.Sleep(vitesse);
                            if (neww != bonhomme.jambe1.Bas.CSG.Y)
                            {
                                neww = bonhomme.jambe1.Bas.CSG.Y;
                            }
                            else
                                old = bonhomme.jambe1.Bas.CSG.Y;
                        }

                        break;
                    case 3:
                        while (dejaDeplacer < (deltaXYmax*2))//Monte&avance jambe 2,avance bonhome 
                        {
                            bonhomme.Cacher(handle);
                            bonhomme.jambe1.BougerBas(-resolution, 0);
                            if(dejaDeplacer < deltaXYmax)
                                bonhomme.jambe2.BougerBas(resolution, -resolution);
                            else
                                bonhomme.jambe2.BougerBas(resolution, 0);
                            bonhomme.Coordonnee = new Point(bonhomme.Coordonnee.X + resolution, bonhomme.Coordonnee.Y);
                            bonhomme.Afficher(handle);
                            dejaDeplacer += resolution;
                            Thread.Sleep(vitesse);
                        }
                        break;
                    case 4:
                        while (bonhomme.jambe2.Bas.CSG.Y < ySol - 1 && old != neww)//Descend jambe 2
                        {
                            bonhomme.Cacher(handle);
                            bonhomme.jambe2.BougerBas(0, resolution);
                            bonhomme.Afficher(handle);
                            dejaDeplacer += resolution;
                            Thread.Sleep(vitesse);
                        }
                        bonhomme.Cacher(handle);
                        bonhomme.InterevrtirJambe();// On inverse les deux jambe, jambe1=jambe2 et jambe2=jambe1
                        bonhomme.Afficher(handle);
                        step+=2;
                        break;
                }
                step++;
            }
        }
        public void CollerAuSol(ref Jambe jambe)
        {
            if (jambe.Bas.CSG.Y != ySol) // On positionne le bonhomme sur le sol
            {
                Graphics gr = Graphics.FromHwnd(handle);
                bonhomme.Cacher(handle);
                Point newCoo;
                int longeurTTBonhome = jambe.Bas.CSG.Y - bonhomme.CIG.Y;// de pied.csg à bonhome.cig
                newCoo = new Point(bonhomme.Coordonnee.X, ySol - longeurTTBonhome);
                bonhomme.Coordonnee = newCoo;
                bonhomme.Afficher(handle);
            }
        }
    }
    
}
